﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CycleThruTabs98652
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
            //Ensure that the form receives key events before the event is passed to the control in focus
            this.KeyPreview = true;

            this.Load += new EventHandler(Form1_Load);
        }

        //Create a variable to store the current active tab's index
        int activeTabIndex;

        void Form1_Load(object sender, EventArgs e)
        {
            this.KeyDown += new KeyEventHandler(Form1_KeyDown);
            ultraTabControl1.SelectedTabChanged += new Infragistics.Win.UltraWinTabControl.SelectedTabChangedEventHandler(ultraTabControl1_SelectedTabChanged);
            
            //Set the activeTabIndex to the currently selected tab, this value will always be zero by default unless developer is activating a different tab
            //Using the currently selected tab's index just in case
            activeTabIndex = ultraTabControl1.SelectedTab.Index;
        }

        void ultraTabControl1_SelectedTabChanged(object sender, Infragistics.Win.UltraWinTabControl.SelectedTabChangedEventArgs e)
        {
            //Update the active tabs index whenever the selected tab changes, this also takes into account the possibility that the user selects another tab
            //by clicking it with the mouse
            activeTabIndex = ultraTabControl1.SelectedTab.Index;
        }

        void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            //Check to see if the Alt + Right directional keys are pressed
            if ((e.KeyCode == Keys.Right) && e.Alt) 
                //if true, fire the nextTab method
                nextTab();

            //Check to see if the Alt + Left directional keys are pressed
            else if ((e.KeyCode == Keys.Left) && e.Alt) previousTab();
                //if true, fire the previousTab method
        }

        void nextTab()
        {
            //Increment the activeTabIndex by one, referencing the next tab in the collection
            activeTabIndex++;
            
            //Ensure that the tab index does not exceed that provided by the collection, if it does, reset to the first position, by setting the value to zero
            if (activeTabIndex > ultraTabControl1.Tabs.Count - 1) activeTabIndex = 0;

            //Select the tab whose index matches the activeTabIndex
            ultraTabControl1.Tabs[activeTabIndex].Selected = true;
        }

        void previousTab()
        {
            //Decrement the activeTabIndex by one, referencing the next tab in the collection
            activeTabIndex--;

            //Ensure that the tab index does not become negative, as this would exceed the lower limit of the tab collection, rather set the value to the last
            //tab's index in the collection
            if (activeTabIndex < 0) activeTabIndex = ultraTabControl1.Tabs.Count - 1;

            //Select the tab whose index matches the activeTabIndex
            ultraTabControl1.Tabs[activeTabIndex].Selected = true;
        }
    }
}
